RealFuelUsage = {};

-- A script to set Vehicle Fuel Usage
-- Author Dajoor.
-- 2019.02.25

-- lastupdate: 2019-02-25 

-- *********** CHANGE THESE DEFAULTS *******************

-- can not be 0. This fuel use data are from AG service agencies: 6 gal per operating hour per 100 HP
RealFuelUsage.basevalue = 6.0 

-- can not be 0. Use this value to adjust the fuel usage to your preference
RealFuelUsage.usemodifier = 2.0 

-- Enable DEF usage. DONT! Not until Giants enables it.
RealFuelUsage.usedef = false

-- *********** DO NOT CHANGE BELOW *********************
-- *********** DO NOT CHANGE BELOW *********************

RealFuelUsage.setonce = false
addModEventListener(RealFuelUsage);

function RealFuelUsage:loadMap(name)
	g_currentMission.environment:addHourChangeListener(RealFuelUsage);
end;

function RealFuelUsage:hourChanged() 
	RealFuelUsage:setDefaults()
end;

function RealFuelUsage:update(dt) 
	if (g_gameStateManager:getGameState() == GameState.PLAY and RealFuelUsage.setonce == false) then
		RealFuelUsage.setonce = true
		RealFuelUsage:setDefaults()
	end;
end;

function RealFuelUsage:setDefaults()
	if (g_currentMission.vehicles ~= nil) then
	
		if (RealFuelUsage.basevalue < 0) then
			RealFuelUsage.basevalue = 6.0
		end;
		if (RealFuelUsage.basevalue > 36) then
			RealFuelUsage.basevalue = 36
		end;
		if (RealFuelUsage.usemodifier < 0) then
			RealFuelUsage.usemodifier = 0.01
		end;
		if (RealFuelUsage.usemodifier > 10) then
			RealFuelUsage.usemodifier = 10
		end;
		local ubase = (3.786 * RealFuelUsage.basevalue) / 3600000
		for _ , v in pairs(g_currentMission.vehicles) do
			if v ~= nil then	
				if (v.spec_motorized ~= nil) then
					local mpow = (v.spec_motorized.motor.peakMotorTorque * 0.85) + 0.5 -- normalized 
					if v.spec_motorized.consumersByFillType[FillType.DIESEL] ~= nil then -- belt fix
						local realuse = (ubase * mpow) -- 6 gal/hr / 100hp in ms
						v.spec_motorized.consumersByFillType[FillType.DIESEL].usage = realuse * RealFuelUsage.usemodifier
					end;
					if (RealFuelUsage.usedef == true) then
						if v.spec_motorized.consumersByFillType[FillType.DEF] ~= nil then -- belt fix
							local defuse = ((ubase / 40) * mpow) -- standard OEM 1:40 ratio
							v.spec_motorized.consumersByFillType[FillType.DEF].usage = defuse * RealFuelUsage.usemodifier
						end;
					end;
				end;
			end;
		end;
	end;
end;